﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_linq_find_primes
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Find primes.
        private void btnGo_Click(object sender, EventArgs e)
        {
            int max = int.Parse(txtMax.Text);

            // Examine numbers to find primes.
            var primes =
                from number in Enumerable.Range(1, max)
                where IsPrime(number)
                select number;

            // Display the results.
            lstPrimes.DataSource = primes.ToList();
        }

        // Return true if the number is prime.
        private bool IsPrime(int number)
        {
            if (number < 2) return false;
            if (number == 2) return true;
            if (number % 2 == 0) return false;
            for (int i = 3; i * i <= number; i += 2)
            {
                if (number % i == 0) return false;
            }
            return true;
        }
    }
}
